<?php
################################################################################
### This disclaimer must be kept intact in order to use this product.        ###
################################################################################
### Project: jT CarFramework [http://intersofts.com]
### Author: J. Toshio Taniguchi
### Since: 27.04.2011
### Version: 1.0.0
### Copyrights: J. Toshio Taniguchi
### Contact: j.taniguchi@taniguchi-blog.com
################################################################################
### CONTRIBUTORS
### - none
################################################################################
class adminnivo {
    protected $lang;
    protected $form_message;
    protected $form_status;
    protected $form_style;
    protected $form_type;
    protected $nivo_data_list;
    protected $nivo_img_list;
    
    /*
     * Constructor -------------------------------------------------------------
     */
    public function adminnivo($lang=array())
    {
        $this->lang = $lang;
        
        // handle config. form.
        if( isset($_POST['configBtn']) )
        {
            $this->handleConfigForm();
        }
        
        // handle new banner form.
        if( isset($_POST['saveBtn']) )
        {
            $this->handleSaveForm();
        }
        
        // handle update form.
        if( isset($_POST['updateBtn']) )
        {
            $this->handleUpdateForm();
        }
        
        // handle delete form.
        if( isset($_POST['deleteBtn']) )
        {
            $this->handleDeleteForm();
        }
        
        // load nivo data.
        $this->loadNivoData();
        
        // load nivo list.
        $this->loadNivoList();
    }
    
    /*
     * Protected method: handle delete banner form -----------------------------
     * @return void.
     */
    protected function handleDeleteForm()
    {
        $id = (int)$_POST['idInput'];
        $source = trim($_POST['sourceInput']);
        
        require_once BASE_CLASS . 'class-connect.php';
        
        $db = new Connect();
        $db->open();
        
        if( !@mysql_query("DELETE FROM `nivo_list` WHERE `id`='$id' LIMIT 1;") )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            $db->close();
            
            LogReport::write('Unable to remove banner due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['NIVO_REMOVE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            $this->form_type = 'bottom';
            return;
        }
        
        $db->close();
        
        // remove image file.
        $path = BASE_ROOT . $source;
        
        if( file_exists($path) )
        {
            @unlink($path);
        }
        
        $this->form_message = $this->lang['NIVO_REMOVE_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        $this->form_type = 'bottom';
        return;
    }
    
    /*
     * Protected method: handle update banner form -----------------------------
     * @return void.
     */
    protected function handleUpdateForm()
    {
        $id = (int)$_POST['idInput'];
        $source = trim($_POST['sourceInput']);
        $caption = trim($_POST['captionInput']);
        $enabled = (bool)$_POST['enabledInput'];
        
        // strip any extra slash added by server.
        $caption = stripslashes($caption);
        
        // update database.
        require_once BASE_CLASS . 'class-connect.php';
        
        $db = new Connect();
        $db->open();
        
        $caption = mysql_real_escape_string($caption);
        ( $enabled ? $enabled = '1' : $enabled = '0' );
        
        if( !@mysql_query("UPDATE `nivo_list` SET `enabled`='$enabled', `caption`='$caption' WHERE `id`='$id' LIMIT 1;") )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            $db->close();
            
            LogReport::write('Unable to update banner data due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['NIVO_UPDATE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            $this->form_type = 'bottom';
            return;
        }
        
        $db->close();
        
        $this->form_message = $this->lang['NIVO_UPDATE_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        $this->form_type = 'bottom';
        return;
    }
    
    /*
     * Protected method: handle save form --------------------------------------
     * @return void.
     */
    protected function handleSaveForm()
    {
        $caption = trim($_POST['captionInput']);
        $enabled = trim($_POST['enabledInput']);
        $extension = trim($_FILES['bannerInput']['name']);
        
        // get max. upload file size.
        $max_upload = (int)(ini_get('upload_max_filesize'));
        $max_post = (int)(ini_get('post_max_size'));
        $memory_limit = (int)(ini_get('memory_limit'));
        $upload_mb = min($max_upload, $max_post, $memory_limit);
        
        // validate enabled var.
        $enabled = (bool)$enabled;
        ( $enabled ? $enabled = '1' : $enabled = '0' );
        
        if( (int)$_FILES['bannerInput']['size'] < 1 )
        {
            $this->form_message = $this->lang['NIVO_INVALID_IMAGE_FILE_ERROR'] . $upload_mb;
            $this->form_status = true;
            $this->form_style = 'alert-error';
            $this->form_type = 'middle';
            return;
        }
        
        // validate extension.
        $extension = explode('.', $extension);
        $extension = $extension[(count($extension)-1)];
        $extension = strtolower($extension);
        
        $valid = true;
        
        switch( $extension )
        {
            case 'jpg':
            case 'png':
            case 'gif':
                break;
            default:
                $valid = false;
        }
        
        if( !$valid )
        {
            $this->form_message = $this->lang['NIVO_INVALID_IMAGE_FILE_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            $this->form_type = 'middle';
            return;
        }
        
        // update banner image.
        $fname = date('ymd') . '_' . date('His') . '_' . mt_rand('0000','9999') . '.' . $extension;
        $path = BASE_ROOT . 'image/banner/' . $fname;
        
        if( !@move_uploaded_file($_FILES['bannerInput']['tmp_name'], $path) )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to upload banner image due a error at ' . __FILE__ . ':' . __LINE__ );
            
            $this->form_message = $this->lang['NIVO_UPLOAD_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            $this->form_type = 'middle';
            return;
        }
        
        // register banner on database.
        require_once BASE_CLASS . 'class-connect.php';
        
        $db = new Connect();
        $db->open();
        
        $caption = mysql_real_escape_string($caption);
        
        if( !@mysql_query("INSERT INTO `nivo_list` (`enabled`,`source`,`caption`) VALUES ('$enabled','image/banner/$fname','$caption')") )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            $db->close();
            
            LogReport::write('Unable to save banner due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            @unlink($path);
            
            $this->form_message = $this->lang['NIVO_UPLOAD_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            $this->form_type = 'middle';
            return;
        }
        
        $this->form_message = $this->lang['NIVO_UPLOAD_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        $this->form_type = 'middle';
        return;
    }
    
    /*
     * Protected method: handle configuration form -----------------------------
     * @return void.
     */
    protected function handleConfigForm()
    {
        $speed          = trim($_POST['speedInput']);
        $pause          = trim($_POST['pauseInput']);
        $nav_controls   = trim($_POST['navInput']);
        $nav_thumb      = trim($_POST['thumbInput']);
        $nav_bullet     = trim($_POST['bulletsInput']);
        $mouse_over     = trim($_POST['mouseoverInput']);
        $manual         = trim($_POST['manualInput']);
        $random         = trim($_POST['randomInput']);
                
        $speed          = (int)$speed;
        $pause          = (int)$pause;
        $nav_controls   = (bool)$nav_controls;
        $nav_thumb      = (bool)$nav_thumb;
        $nav_bullet     = (bool)$nav_bullet;
        $mouse_over     = (bool)$mouse_over;
        $manual         = (bool)$manual;
        $random         = (bool)$random;
        
        // validate.
        if( $speed < 500 ) // half sec. is the min. allowed.
        {
            $this->form_message = $this->lang['NIVO_INVALID_SPEED'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            $this->form_type = 'top';
            return;
        }
        
        if( $pause < 1000 ) // min. 1 second.
        {
            $this->form_message = $this->lang['NIVO_INVALID_PAUSE'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            $this->form_type = 'top';
            return;
        }
        
        // set boolean values to string.
        ( $nav_bullet ? $nav_bullet = '1' : $nav_bullet = '0' );
        ( $nav_controls ? $nav_controls = '1' : $nav_controls = '0' );
        ( $nav_thumb ? $nav_thumb = '1' : $nav_thumb = '0' );
        ( $mouse_over ? $mouse_over = '1' : $mouse_over = '0' );
        ( $manual ? $manual = '1' : $manual = '0' );
        ( $random ? $random = '1' : $random = '0' );
        
        // update database.
        require_once BASE_CLASS . 'class-connect.php';
        
        $db = new Connect();
        $db->open();
        
        if( !@mysql_query("UPDATE `nivo_config` SET `animation_speed`='$speed',
                                                    `pause_time`='$pause',
                                                    `display_direction_navigation`='$nav_controls',
                                                    `control_navigation_thumbs`='$nav_thumb',
                                                    `control_navigation_bullets`='$nav_bullet',
                                                    `pause_onmouse_hover`='$mouse_over',
                                                    `manual_advance`='$manual',
                                                    `random_start`='$random' LIMIT 1;") )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            $db->close();
            
            LogReport::write('Unable to update nivo configuration table due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $this->form_message = $this->lang['NIVO_UPDATE_CONFIG_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            $this->form_type = 'top';
            return;
        }
        
        $this->form_message = $this->lang['NIVO_UPDATE_CONFIG_QUERY_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        $this->form_type = 'top';
        return;
    }
    
    /*
     * Protected method: load nivo slider config. data -------------------------
     * @return void.
     */
    protected function loadNivoData()
    {
        require_once BASE_CLASS . 'class-connect.php';
        
        $db = new Connect();
        $db->open();
        
        if( !$sql = @mysql_query("SELECT * FROM `nivo_config` LIMIT 1;") )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            $db->close();
            
            LogReport::write('Unable to load nivo configuration data due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            LogReport::fatalError($this->lang['NIVO_DATA_QUERY_LOAD_ERROR']);
        }
        
        if( @mysql_num_rows($sql) != 1 )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            $db->close();
            
            LogReport::write('Nivo slider configuration has no data registered on database. Error thrown at ' . __FILE__ . ':' . __LINE__ . '.');
            LogReport::fatalError($this->lang['NIVO_DATA_QUERY_LOAD_ERROR']);
        }
        
        $this->nivo_data_list = array();
        
        $r = @mysql_fetch_assoc($sql);
        @mysql_free_result($sql);
        
        $db->close();
        
        $this->nivo_data_list['id']                             = (int)$r['id'];
        $this->nivo_data_list['animation_speed']                = (int)$r['animation_speed'];
        $this->nivo_data_list['pause_time']                     = (int)$r['pause_time'];
        $this->nivo_data_list['display_direction_navigation']   = (bool)$r['display_direction_navigation'];
        $this->nivo_data_list['control_navigation_thumbs']      = (bool)$r['control_navigation_thumbs'];
        $this->nivo_data_list['control_navigation_bullets']     = (bool)$r['control_navigation_bullets'];
        $this->nivo_data_list['pause_onmouse_hover']            = (bool)$r['pause_onmouse_hover'];
        $this->nivo_data_list['manual_advance']                 = (bool)$r['manual_advance'];
        $this->nivo_data_list['preview_text']                   = $r['preview_text'];
        $this->nivo_data_list['next_text']                      = $r['next_text'];
        $this->nivo_data_list['random_start']                   = (bool)$r['random_start'];
    }
    
    /*
     * Protected method: load nivo image list ----------------------------------
     * @return void.
     */
    protected function loadNivoList()
    {
        require_once BASE_CLASS . 'class-connect.php';
        
        $db = new Connect();
        $db->open();
        
        if( !$sql = @mysql_query("SELECT * FROM `nivo_list` ORDER BY `id` DESC") )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to load nivo image list due a query error at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            LogReport::fatalError($this->lang['NIVO_IMAGE_QUERY_LOADER_ERROR']);
        }
        
        $this->nivo_img_list = array();
        
        if( @mysql_num_rows($sql) > 0 )
        {
            while( $r = @mysql_fetch_assoc($sql) )
            {
                $obj = array(
                    'id' => (int)$r['id'],
                    'enabled' => (bool)$r['enabled'],
                    'source' => stripslashes($r['source']),
                    'caption' => stripslashes($r['caption'])
                );
                
                array_push($this->nivo_img_list, $obj);
            }
            
            @mysql_free_result($sql);
        }
        
        $db->close();
    }
    
    /*
     * Public method: get configuration list -----------------------------------
     * @return array.
     */
    public function getDataList()
    {
        return $this->nivo_data_list;
    }
    
    /*
     * Public method: get image list -------------------------------------------
     * @return array.
     */
    public function getImageList()
    {
        return $this->nivo_img_list;
    }
    
    /*
     * Public method: get form status ------------------------------------------
     * @return bool.
     */
    public function getFormStatus()
    {
        return $this->form_status;
    }
    
    /*
     * Public method: get form message -----------------------------------------
     * @return string.
     */
    public function getFormMessage()
    {
        return $this->form_message;
    }
    
    /*
     * Public method: get form style -------------------------------------------
     * @return string.
     */
    public function getFormStyle()
    {
        return $this->form_style;
    }
    
    /*
     * Public method: get form type --------------------------------------------
     * @return string.
     */
    public function getFormType()
    {
        return $this->form_type;
    }
}
